<?xml version="1.0" encoding="UTF-8" ?>

<!--
StarXpert_Xml2Calc - An OpenOffice.org import filter.
Copyright (C) 2005  Galmes Pierre-Andre

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-->

<!-- NB : les en-tete de document OOo sont mis automatiquement. --> 
<xsl:stylesheet 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
	xmlns:office="http://openoffice.org/2000/office"
	xmlns:style="http://openoffice.org/2000/style"
	xmlns:text="http://openoffice.org/2000/text"
	xmlns:table="http://openoffice.org/2000/table"
	xmlns:draw="http://openoffice.org/2000/drawing"
	xmlns:fo="http://www.w3.org/1999/XSL/Format"
	xmlns:xlink="http://www.w3.org/1999/xlink"
	xmlns:number="http://openoffice.org/2000/datastyle"
	xmlns:svg="http://www.w3.org/2000/svg" 
	xmlns:chart="http://openoffice.org/2000/chart" 
	xmlns:dr3d="http://openoffice.org/2000/dr3d" 
	xmlns:math="http://www.w3.org/1998/Math/MathML" 
	xmlns:form="http://openoffice.org/2000/form" 
	xmlns:script="http://openoffice.org/2000/script" 
	xmlns:meta="http://openoffice.org/2000/meta" 
	version="1.0" 
	office:class="spreadsheet"
	office:version="1.0">
	
<xsl:output method="xml" indent="yes" omit-xml-declaration="no"/>

<!-- Revoir a quoi cela sert. -->
<xsl:strip-space elements="*" />

<xsl:template match="/"> 

<!-- Le document OpenOffice. -->
<office:document>

        <office:automatic-styles>
		<xsl:call-template name="array_styles"/>
        </office:automatic-styles>

	<office:body>
		<xsl:call-template name="feuille_import"/>
	</office:body>

</office:document>

</xsl:template>



<!-- Styles dont OpenOffice a besoin pour mettre en forme la spreadsheet. -->
<xsl:template name="array_styles">

	<style:style
		style:name="co1"
		style:family="table-column">

		<style:properties fo:break-before="auto"
			style:column-width="2.267cm"/>
	</style:style>

	<style:style style:name="ro1" style:family="table-row">

		<style:properties style:row-height="0.427cm"
			fo:break-before="auto"
			style:use-optimal-row-height="true"/>
	</style:style>

	<style:style style:name="ta1" style:family="table"
		style:master-page-name="Default">
		<style:properties
			table:display="true"/>
	</style:style>
	
</xsl:template>


<!-- Nom de la feuille qui va importer le xml. -->
<xsl:template name="feuille_import">
	<table:table
		table:name="Feuille Import"
		table:style-name="ta1">

		<xsl:call-template name="headerRow"/>
		
		<xsl:for-each select="/*/child::*"> 
			<xsl:call-template name="myrow"/>
		</xsl:for-each> 

	</table:table>

	
</xsl:template>


<!-- Inutile dans pour l'instant : Nom des feuilles qui ne vont pas importer de xml. -->
<xsl:template name="simple_feuille">
	
</xsl:template>




<!-- Header Rox... -->

<!-- Ligne d'en-tete contenant le nom des elements. -->
<xsl:template name="headerRow">

	<table:table-row table:style-name="ro1">
		<!--
		<xsl:for-each select="./*/descendant::*"> 
		<xsl:value-of select="./*/descendant::*"/>
			<xsl:if test="position() = last()">
			</xsl:if>
		<xsl:value-of select="./*/self"/>
		<xsl:for-each select="./*/descendant[1]"> 
		-->

		
		<xsl:for-each select="./*/*[1]/descendant-or-self::*"> 
				<xsl:call-template name="headercell"/>		
		</xsl:for-each> 
	</table:table-row>
	
</xsl:template>



<xsl:template name="headercell">
	<table:table-cell>
		
		<text:p>
			<xsl:value-of select="normalize-space(name())"/>
			<!--
			<xsl:text> name() </xsl:text>
			-->

		</text:p>
	</table:table-cell>
</xsl:template>


<!-- -->
<xsl:template name="myrow">

	<table:table-row table:style-name="ro1">
		<xsl:for-each select="./descendant-or-self::*"> 
			
			<!--
			<xsl:if test = "count(.) = 1">
				<xsl:text> YOUYOUYOU </xsl:text>
			</xsl:if>
			
			<xsl:if test="count(.) != 1">
				<xsl:text> PASPASPASP </xsl:text>
			</xsl:if>
			-->

			<xsl:call-template name="mycell"/>		
		</xsl:for-each> 
		<!--
		-->
	</table:table-row>
	
</xsl:template>

<!-- -->
<xsl:template name="mycell">
	<table:table-cell>
		
		<text:p>
			<xsl:value-of select="normalize-space(text())"/>
			<!--
			<xsl:value-of select="normalize-space(./self::text())"/>
			-->
		</text:p>
	</table:table-cell>
</xsl:template>

</xsl:stylesheet>
